var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as React from 'react';
import defaultOptions from '../../defaultOptions';
import { getField } from '../../Utils/ColumnUtils';
import { getValueByColumn } from '../../Utils/DataUtils';
import CellContent from '../CellContent/CellContent';
import CellEditor from '../CellEditor/CellEditor';
var CellComponent = function (props) {
    var column = props.column, style = props.column.style, editorValue = props.editorValue, hasEditorValue = props.hasEditorValue, isEditableCell = props.isEditableCell, rowData = props.rowData;
    var value = hasEditorValue ? editorValue : getValueByColumn(rowData, column);
    return (React.createElement("td", { style: style, className: defaultOptions.css.cell }, isEditableCell ? (React.createElement(CellEditor, __assign({}, props, { value: value, field: getField(column) })))
        : (React.createElement(CellContent, __assign({}, props, { value: value, field: getField(column) })))));
};
export default CellComponent;