import React from 'react';
import { getEditableCell } from '../../Utils/CellUtils';
import { getRowEditableCells } from '../../Utils/FilterUtils';
import CellComponent from '../CellComponent/CellComponent';
var DataRowContent = function (_a) {
    var childAttributes = _a.childAttributes, columns = _a.columns, dispatch = _a.dispatch, editableCells = _a.editableCells, editingMode = _a.editingMode, isDetailsRowShown = _a.isDetailsRowShown, isSelectedRow = _a.isSelectedRow, rowData = _a.rowData, rowKeyField = _a.rowKeyField, rowKeyValue = _a.rowKeyValue;
    var rowEditableCells = getRowEditableCells(rowKeyValue, editableCells);
    return (React.createElement(React.Fragment, null, columns.map(function (column) {
        var editableCell = getEditableCell(column, rowEditableCells);
        return (React.createElement(CellComponent, { childAttributes: childAttributes, column: column, dispatch: dispatch, editingMode: editingMode, isEditableCell: !!editableCell, isDetailsRowShown: isDetailsRowShown, isSelectedRow: isSelectedRow, editorValue: editableCell && editableCell.editorValue, validationMessage: editableCell && editableCell.validationMessage, hasEditorValue: editableCell && editableCell.hasOwnProperty('editorValue'), key: column.key, rowData: rowData, rowKeyField: rowKeyField, rowKeyValue: rowKeyValue }));
    })));
};
export default DataRowContent;