import React, { useEffect, useRef } from 'react';
import { newRowId } from '../../const';
import { getGroupMark, getGroupText } from '../../Utils/GroupUtils';
import DataAndDetailsRows from '../DataAndDetailsRows/DataAndDetailsRows';
import GroupRow from '../GroupRow/GroupRow';
import NewRow from '../NewRow/NewRow';
var Rows = function (props) {
    var columns = props.columns, data = props.data, dispatch = props.dispatch, editableCells = props.editableCells, groupColumnsCount = props.groupColumnsCount, groupRow = props.groupRow, groupedColumns = props.groupedColumns, _a = props.groups, groups = _a === void 0 ? [] : _a, _b = props.groupsExpanded, groupsExpanded = _b === void 0 ? [] : _b, detailsRow = props.detailsRow, _c = props.detailsRows, detailsRows = _c === void 0 ? [] : _c, onFirstRowRendered = props.onFirstRowRendered, rowKeyField = props.rowKeyField, selectedRows = props.selectedRows;
    var groupMark = getGroupMark();
    var firstRowRef = useRef(null);
    useEffect(function () {
        onFirstRowRendered(firstRowRef);
    }, [firstRowRef, onFirstRowRendered]);
    var rowRefLink = firstRowRef;
    var newRowEditableCells = editableCells && editableCells.filter(function (c) { return c.rowKeyValue === newRowId; });
    return (React.createElement(React.Fragment, null,
        newRowEditableCells && !!newRowEditableCells.length && (React.createElement(NewRow, { childAttributes: props.childAttributes, editableCells: newRowEditableCells, columns: columns, dispatch: dispatch, groupColumnsCount: groupColumnsCount, rowKeyField: rowKeyField })),
        data.map(function (d) {
            if (d.groupMark === groupMark) {
                var groupIndex = d.key.length - 1;
                var group_1 = groups && groups[groupIndex];
                var column = group_1 && groupedColumns.find(function (c) { return c.key === group_1.columnKey; });
                return (React.createElement(GroupRow, { column: column, contentColSpan: columns.length - groupIndex + groups.length, dispatch: dispatch, groupIndex: groupIndex, groupKey: d.key, groupRow: groupRow, isExpanded: groupsExpanded.some(function (ge) { return JSON.stringify(ge) === JSON.stringify(d.key); }), text: getGroupText(d.value, column), key: d.key }));
            }
            else {
                var rowKeyValue_1 = d[rowKeyField];
                var isSelectedRow = selectedRows.some(function (s) { return s === rowKeyValue_1; });
                var isDetailsRowShown = !!detailsRow && detailsRows.some(function (r) { return r === rowKeyValue_1; });
                var dataRow = (React.createElement(DataAndDetailsRows, { childAttributes: props.childAttributes, columns: props.columns, dataRow: props.dataRow, dispatch: props.dispatch, editableCells: props.editableCells, editingMode: props.editingMode, groupColumnsCount: props.groupColumnsCount, detailsRow: detailsRow, isDetailsRowShown: isDetailsRowShown, isSelectedRow: isSelectedRow, key: d[rowKeyField], rowData: d, rowKeyField: props.rowKeyField, rowKeyValue: rowKeyValue_1, selectedRows: props.selectedRows, trRef: rowRefLink }));
                rowRefLink = undefined;
                return dataRow;
            }
        })));
};
export default Rows;